unit uPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdFTP, ComCtrls, Buttons, ImgList;

type
  TfrmMyFTP = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    ProgressBar1: TProgressBar;
    IdFTP1: TIdFTP;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    OpenDialog1: TOpenDialog;
    GroupBox4: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TBitBtn;
    Button2: TBitBtn;
    Button4: TBitBtn;
    edtHost: TEdit;
    edtUser: TEdit;
    edtPass: TEdit;
    ImageList1: TImageList;
    procedure IdFTP1Status(ASender: TObject; const AStatus: TIdStatus;
      const AStatusText: String);
    procedure IdFTP1Work(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCount: Integer);
    procedure IdFTP1WorkBegin(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCountMax: Integer);
    procedure IdFTP1WorkEnd(Sender: TObject; AWorkMode: TWorkMode);
    procedure Edit1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure edtHostChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMyFTP: TfrmMyFTP;

implementation

uses uThread;

var
ThreadUpload : TUpload;


{$R *.dfm}

procedure TfrmMyFTP.IdFTP1Status(ASender: TObject; const AStatus: TIdStatus;
  const AStatusText: String);
begin
Label3.Caption := 'Outras informaes: ' + AStatusText;
end;

procedure TfrmMyFTP.IdFTP1Work(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCount: Integer);
Var
 Transferido : Integer;
begin
      Transferido := AWorkCount div 1024;
      Label2.Caption := 'Transferido: ' + IntToStr(Transferido) + '/kb.';
      ProgressBar1.Position := AWorkCount;
end;

procedure TfrmMyFTP.IdFTP1WorkBegin(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCountMax: Integer);
begin
      ProgressBar1.Position := 0;
      ProgressBar1.Max := AWorkCountMax;
end;

procedure TfrmMyFTP.IdFTP1WorkEnd(Sender: TObject; AWorkMode: TWorkMode);
begin
      ProgressBar1.Position := ProgressBar1.Max;
      Label2.Caption := 'Upload Concludo!';
      Button1.Enabled := True;
      Button2.Enabled := False;
      Button4.Enabled := False;
      ThreadUpload.Terminate;
end;

procedure TfrmMyFTP.Edit1Click(Sender: TObject);
begin
if OpenDialog1.Execute then begin
    Edit1.Text:=OpenDialog1.FileName;
    If (Length(Trim(edtHost.Text)) > 0) and
       (Length(Trim(edtUser.Text)) > 0) and
       (Length(Trim(edtPass.Text)) > 0) then
       begin
           IdFTP1.Host := Trim(edtHost.Text);
           IdFTP1.Username := Trim(edtUser.Text);
           IdFTP1.Password := Trim(edtPass.Text);
           Button1.Enabled := True;
      end
      else
           Button1.Enabled := False;
end;
end;

procedure TfrmMyFTP.BitBtn1Click(Sender: TObject);
begin
  ThreadUpload := Tupload.Criar(idFTP1, Edit1);
  Button1.Enabled := False;
  Button2.Enabled := True;
  Button4.Enabled := True;
end;

procedure TfrmMyFTP.BitBtn2Click(Sender: TObject);
begin

If TBitBtn(Sender).Caption = 'Pausar' then begin
    TBitBtn(Sender).Caption := 'Continuar';
    TBitBtn(Sender).Glyph := nil;
    ImageList1.GetBitmap(0, TBitBtn(Sender).Glyph);
    ThreadUpload.Suspend;
end else

If TBitBtn(Sender).Caption = 'Continuar' then begin
    TBitBtn(Sender).Caption := 'Pausar';
    TBitBtn(Sender).Glyph := nil;
    ImageList1.GetBitmap(1, TBitBtn(Sender).Glyph);
    ThreadUpload.Resume;
end;
end;

procedure TfrmMyFTP.BitBtn3Click(Sender: TObject);
begin
    ThreadUpload.Suspend;
    idFTP1.Abort;
    ThreadUpload.Terminate;
    IdFTP1.Quit;
    Button4.Enabled := False;
    Button2.Enabled := False;
    Button1.Enabled := True;
    ProgressBar1.Position := 0;
    Label2.Caption := 'Upload Cancelado!';

end;

procedure TfrmMyFTP.edtHostChange(Sender: TObject);
begin
If (Length(Trim(edtHost.Text)) > 0) and
   (Length(Trim(edtUser.Text)) > 0) and
   (Length(Trim(edtPass.Text)) > 0) and
   (Trim(Edit1.Text) <> 'Clique para selecionar o arquivo para UpLoad') then
    begin
      IdFTP1.Host := Trim(edtHost.Text);
      IdFTP1.Username := Trim(edtUser.Text);
      IdFTP1.Password := Trim(edtPass.Text);
      Button1.Enabled := True
    end
    else
      Button1.Enabled := False;
end;

procedure TfrmMyFTP.FormActivate(Sender: TObject);
begin
    ImageList1.GetBitmap(0, Button1.Glyph);
    ImageList1.GetBitmap(1, Button2.Glyph);
    ImageList1.GetBitmap(2, Button4.Glyph);
    edtHost.SetFocus;
end;

end.
